<template>
  <div class="flex flex-col pb-8 h-full">
    <OfferBadge
      v-if="offerText"
      :text="offerText"
    />
    <ReferOutModal
      v-if="refer"
    />
    <common-navbar
      :current-status-number="currentStatusNumber"
    >
      <CommonLogo v-if="currentQuiz.displayLogo"/>
      <img
        v-else-if="currentQuiz.displayBackBtn"
        src="@/assets/img/icons/arrow.png"
        class="w-5 cursor-pointer"
        alt="back-btn"
      >
      <div v-else></div>
      <div
        class="text-center text-base font-semibold max-w-quiz absolute left-1/2 transform -translate-x-1/2"
        v-if="currentQuiz.title"
      >
        {{ currentQuiz.title }}
      </div>
      <div
        class="border border-green flex rounded-md py-2 px-5 text-sm font-bold cursor-pointer"
        @click="isHelpDisplayed = true"
      >
        Help?
      </div>
    </common-navbar>
    <OrderSummary v-if="displayOrderSummary"/>
    <main class="relative flex-auto mt-8 flex flex-col px-5 sm:px-0 max-w-quiz w-full mx-auto">
      <transition name="fast-fade">
        <div class="rounded-lg bg-green-sdark absolute top-0 p-5 flex flex-col z-20" v-if="isHelpDisplayed">
          <div class="text-xl font-semibold text-white pr-8 mb-3">
            Not sure which product is right for you?
          </div>
          <div class="text-white font-medium">Give us a call at <a href="tel:8779074047" class="text-green">(877)
            907-4047</a> to speak with one of our friendly consultants.
          </div>
          <div
            class="cursor-pointer absolute right-5 top-5 flex items-center justify-center w-4 h-4"
            @click="isHelpDisplayed = false"
          >
            <CloseIcon bg-color="bg-white"/>
          </div>
        </div>
      </transition>
      <Component
        :is="currentQuiz.component"
        @nextStage="nextStage"
      />
    </main>
  </div>
</template>

<script>
import CommonNavbar from "@/components/common/CommonNavbar";
import CommonLogo from "@/components/common/CommonLogo";
import {answersMixin, offerMixin, referMixin} from "@/utils/mixins";
import CloseIcon from "@/components/icons/CloseIcon";
import GetStarted from "@/components/quizzes/GetStarted";
import Interstitial from "@/components/quizzes/Interstitial";
import YourHair from "@/components/quizzes/YourHair/YourHair";
import TheBasics from "@/components/quizzes/TheBasics/TheBasics";
import OfferBadge from "@/components/misc/OfferBadge";
import YourHealth from "@/components/quizzes/YourHealth/YourHealth";
import Analyzing from "@/components/quizzes/Analyzing";
import YourResults from "@/components/quizzes/YourResults";
import WhatToExpect from "@/components/quizzes/WhatToExpect/WhatToExpect";
import VisitSummary from "@/components/quizzes/VisitSummary/VisitSummary";
import Shipping from "@/components/quizzes/Shipping";
import Checkout from "@/components/quizzes/Checkout";
import Confirmation from "@/components/quizzes/Confirmation";
import ReferOutModal from "@/components/modals/ReferOutModal";
import OrderSummary from "@/components/misc/OrderSummary";

export default {
  mixins: [answersMixin, referMixin, offerMixin],
  name: "PageQuiz",
  components: {
    OrderSummary,
    ReferOutModal,
    OfferBadge,
    CloseIcon,
    CommonLogo,
    CommonNavbar
  },
  data() {
    return {
      quizStages: {
        1: {
          component: GetStarted,
          displayLogo: true
        },
        2: {
          component: Interstitial,
          displayLogo: true
        },
        3: {
          component: YourHair,
          title: 'Your Hair',
          displayBackBtn: true,
        },
        4: {
          component: TheBasics,
          title: 'The Basics',
          displayBackBtn: true,
        },
        5: {
          component: YourHealth,
          title: 'Your Health',
          displayBackBtn: true
        },
        6: {
          component: Analyzing,
          title: 'Analyzing',
          displayBackBtn: true
        },
        7: {
          component: YourResults,
          title: 'Your Results',
          displayBackBtn: true
        },
        8: {
          component: WhatToExpect,
          title: 'What to Expect',
          displayBackBtn: true
        },
        9: {
          component: VisitSummary,
          title: 'Visit Summary',
          displayBackBtn: true
        },
        10: {
          component: Shipping,
          title: 'Shipping',
          displayBackBtn: true
        },
        11: {
          component: Checkout,
          title: 'Checkout',
          displayBackBtn: true
        },
        12: {
          component: Confirmation,
          title: 'Confirmation',
          displayBackBtn: true
        }
      },
      isHelpDisplayed: false,
      currentStageIndex: 1,
    }
  },
  computed: {
    currentQuiz() {
      return this.quizStages[this.currentStageIndex]
    },
    displayOrderSummary() {
      return [10, 11].includes(this.currentStageIndex)
    },
    currentStatusNumber() {
      let number = null

      switch (this.currentStageIndex) {
        case 3:
          number = 1
          break;
        case 4:
          number = 2
          break;
        case 5:
          number = 3
          break;
        case 6:
          number = 3
          break;
        default:
          number = null
      }

      return number
    },
  },
  methods: {
    nextStage() {
      this.currentStageIndex++
    },
  },
}
</script>

<style scoped>

</style>
